#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _dionicar{
	char ime[31];
	int brdio;
	struct _dionicar *next;
}dionicar;

dionicar* trgovina(dionicar* first, char* ime1, char* ime2)
{
	dionicar *pom1, *pom2;

	//trazimo dionicara ime1
	for(pom1=first; pom1; pom1=pom1->next){
		if(!strcmp(pom1->ime,ime1)){
			break;
		}
	}
	//ukoliko ga nisamo nasli, izlazimo iz funkcije
	if(!pom1)
		return first;

	//slucaj kad je dionicar ime2 na prvom mjestu vezane liste
	if(!strcmp(first->ime,ime2)){
		pom1->brdio+=first->brdio;
		pom2=first;
		first=first->next;
		free(pom2);
		return first;
	}

	//slucaj kad je dionicar ime2 iza prvog mjesta vezane liste
	for(pom2=first; pom2->next; pom2=pom2->next){
		if(!strcmp(pom2->next->ime,ime2)){
			break;
		}
	}
	if(!pom2->next)
		return first;
	pom1->brdio+=pom2->next->brdio;
	pom1=pom2->next;
	pom2->next=pom1->next;
	free(pom1);
	return first;
}

//pomocna funkcija (koristimo je u funkciji najbogatiji) koja vraca pokazivac na element s najvise dionica
dionicar* max(dionicar* first)
{	
	if(!first)
		return first;

	dionicar* pommax=first, *pom;
	int brmax=first->brdio;

	for(pom=first; pom; pom=pom->next){
		if(pom->brdio>brmax){
			brmax=pom->brdio;
			pommax=pom;
		}
	}

	return pommax;
}

//pomocna funkcija (koristimo je u funkciji najbogatiji) koja vezanoj listi dodaje element novi tako da ostane
//sortirana silazno po broju dionica)
void ubaci(dionicar** first, dionicar* novi)
{
	dionicar* pom=*first;	

	if(!*first || novi->brdio>(*first)->brdio){
		novi->next=*first;
		*first=novi;
	}
	else{
		while(pom->next && pom->next->brdio>novi->brdio)
			pom=pom->next;
		novi->next=pom->next;
		pom->next=novi;
	}
}

dionicar* najbogatiji(dionicar** first)
{
	dionicar* pom, *novi, *firstnovi=NULL;
	int n=0, br;
	
	//provjeravamo je li ulazna lista prazna	
	if(!*first)
		return *first;

	//odredjujemo broj dionicara
	for(pom=*first; pom; pom=pom->next)
		n++;

	//broj najbogatijih koje izdvajamo
	br=(n>=20)?(int)n*0.05:1;

	while(br--){
		novi=max(*first);
		
		if(novi==*first)
			*first=(*first)->next;
		else{
			pom=*first;
			while(pom->next && pom->next!=novi)
				pom=pom->next;
			pom->next=novi->next;
		}
		ubaci(&firstnovi,novi);	
	}

	return firstnovi;
}

//za tesitranje nam treba ispis
void ispis(dionicar* first)
{
	while(first){
		printf("%s %d\n", first->ime, first->brdio);
		first=first->next;
	}
	printf("\n");
}

int main(void)
{
	FILE *in;
	dionicar *first=NULL, *novi, *pom;
	char ime[31];
	int brdio;

	if((in=fopen("dionicari.txt","rt"))==NULL){
		printf("Greska prilikom otvaranja datoteke!");
		exit(1);
	}
	
	while(fscanf(in,"%s %d", ime, &brdio)>0){
		novi=(dionicar*)malloc(sizeof(dionicar));
		strcpy(novi->ime,ime);
		novi->brdio=brdio;
		
		if(!first)
			pom=first=novi;
		else{
			pom->next=novi;
			pom=pom->next;
		}
	}
	pom->next=NULL;
	
	ispis(first);
	
	first=trgovina(first,"Ante","Jelena");
	ispis(first);

	first=trgovina(first,"Ante","Emanuel");
	ispis(first);

	novi=najbogatiji(&first);
	ispis(first);
	ispis(novi);

	for(pom=first; pom; pom=first){
		pom=first;
		first=first->next;
		free(pom);
	}

	return 0;
}
