#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _djeca{
	char ime[26];
	int brsl;
	struct _djeca *next;
}djeca;

djeca* igra(djeca* first, char* dijete1, char* dijete2)
{
	djeca *pom1, *pom2;

	//trazimo dijete dijete1
	for(pom1=first; pom1; pom1=pom1->next){
		if(!strcmp(pom1->ime,dijete1)){
			break;
		}
	}
	//ukoliko ga nisamo nasli, izlazimo iz funkcije
	if(!pom1)
		return first;

	//slucaj kad je dijete dijete2 na prvom mjestu vezane liste
	if(!strcmp(first->ime,dijete2)){
		pom1->brsl+=first->brsl;
		pom2=first;
		first=first->next;
		free(pom2);
		return first;
	}

	//slucaj kad je dijete dijete2 iza prvog mjesta vezane liste
	for(pom2=first; pom2->next; pom2=pom2->next){
		if(!strcmp(pom2->next->ime,dijete2)){
			break;
		}
	}
	if(!pom2->next)
		return first;
	pom1->brsl+=pom2->next->brsl;
	pom1=pom2->next;
	pom2->next=pom1->next;
	free(pom1);
	return first;
}

//pomocna funkcija (koristimo je u funkciji najbolji) koja vraca pokazivac na element (dijete) s najvise slicica
djeca* max(djeca* first)
{	
	if(!first)
		return first;

	djeca* pommax=first, *pom;
	int brmax=first->brsl;

	for(pom=first; pom; pom=pom->next){
		if(pom->brsl>brmax){
			brmax=pom->brsl;
			pommax=pom;
		}
	}

	return pommax;
}

//pomocna funkcija (koristimo je u funkciji najbolji) koja vezanoj listi dodaje element novi tako da ostane
//sortirana silazno po broju slicica)
void ubaci(djeca** first, djeca* novi)
{
	djeca* pom=*first;	

	if(!*first || novi->brsl>(*first)->brsl){
		novi->next=*first;
		*first=novi;
	}
	else{
		while(pom->next && pom->next->brsl>novi->brsl)
			pom=pom->next;
		novi->next=pom->next;
		pom->next=novi;
	}
}

djeca* najbolji(djeca** first)
{
	djeca* pom, *novi, *firstnovi=NULL;
	int n=0, br;
	
	//provjeravamo je li ulazna lista prazna	
	if(!*first)
		return *first;

	//odredjujemo broj djece
	for(pom=*first; pom; pom=pom->next)
		n++;

	//broj najboljih koje izdvajamo
	br=(n>=10)?(int)n*0.1:1;

	while(br--){
		novi=max(*first);
		
		if(novi==*first)
			*first=(*first)->next;
		else{
			pom=*first;
			while(pom->next && pom->next!=novi)
				pom=pom->next;
			pom->next=novi->next;
		}
		ubaci(&firstnovi,novi);	
	}

	return firstnovi;
}

//za tesitranje nam treba ispis
void ispis(djeca* first)
{
	while(first){
		printf("%s %d\n", first->ime, first->brsl);
		first=first->next;
	}
	printf("\n");
}

int main(void)
{
	FILE *in;
	djeca *first=NULL, *novi, *pom;
	char ime[26];
	int brsl;

	if((in=fopen("djeca.txt","rt"))==NULL){
		printf("Greska prilikom otvaranja datoteke!");
		exit(1);
	}
	
	while(fscanf(in,"%s %d", ime, &brsl)>0){
		novi=(djeca*)malloc(sizeof(djeca));
		strcpy(novi->ime,ime);
		novi->brsl=brsl;
		
		if(!first)
			pom=first=novi;
		else{
			pom->next=novi;
			pom=pom->next;
		}
	}
	pom->next=NULL;
	
	ispis(first);
	
	first=igra(first,"Ante","Jelena");
	ispis(first);

	first=igra(first,"Ante","Emanuel");
	ispis(first);

	novi=najbolji(&first);
	ispis(first);
	ispis(novi);

	for(pom=first; pom; pom=first){
		pom=first;
		first=first->next;
		free(pom);
	}

	return 0;
}
