#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _tvrtka{
	char naziv[51];
	double vrijednost;
	struct _tvrtka *next;
}tvrtka;

tvrtka* igra(tvrtka* first, char* naziv1, char* naziv2)
{
	tvrtka *pom1, *pom2;

	//trazimo tvrtku naziv1
	for(pom1=first; pom1; pom1=pom1->next){
		if(!strcmp(pom1->naziv,naziv1)){
			break;
		}
	}
	//ukoliko je nisamo nasli, izlazimo iz funkcije
	if(!pom1)
		return first;

	//slucaj kad je tvrtka naziv2 na prvom mjestu vezane liste
	if(!strcmp(first->naziv,naziv2)){
		pom1->vrijednost+=first->vrijednost;
		pom2=first;
		first=first->next;
		free(pom2);
		return first;
	}

	//slucaj kad je tvrtka naziv2 iza prvog mjesta vezane liste
	for(pom2=first; pom2->next; pom2=pom2->next){
		if(!strcmp(pom2->next->naziv,naziv2)){
			break;
		}
	}
	if(!pom2->next)
		return first;
	pom1->vrijednost+=pom2->next->vrijednost;
	pom1=pom2->next;
	pom2->next=pom1->next;
	free(pom1);
	return first;
}

//pomocna funkcija (koristimo je u funkciji predstecaj) koja vraca pokazivac na element (tvrtku) s najmanjom
//vrijenoscu
tvrtka* min(tvrtka* first)
{	
	if(!first)
		return first;

	tvrtka* pommin=first, *pom;
	double brmin=first->vrijednost;

	for(pom=first; pom; pom=pom->next){
		if(pom->vrijednost<brmin){
			brmin=pom->vrijednost;
			pommin=pom;
		}
	}

	return pommin;
}

//pomocna funkcija (koristimo je u funkciji predstecaj) koja vezanoj listi dodaje element novi tako da ostane
//sortirana uzlazno po vrijednosti tvrtki)
void ubaci(tvrtka** first, tvrtka* novi)
{
	tvrtka* pom=*first;	

	if(!*first || novi->vrijednost<(*first)->vrijednost){
		novi->next=*first;
		*first=novi;
	}
	else{
		while(pom->next && pom->next->vrijednost<novi->vrijednost)
			pom=pom->next;
		novi->next=pom->next;
		pom->next=novi;
	}
}

tvrtka* predstecaj(tvrtka** first)
{
	tvrtka* pom, *novi, *firstnovi=NULL;
	int n=0, br;
	
	//provjeravamo je li ulazna lista prazna	
	if(!*first)
		return *first;

	//odredjujemo broj tvrtki
	for(pom=*first; pom; pom=pom->next)
		n++;

	//broj najlosijih koje izdvajamo
	br=(n*0.05-(int)(n*0.05)==0)?(int)n*0.05:(int)n*0.05+1;
	
	while(br--){
		novi=min(*first);
		
		if(novi==*first)
			*first=(*first)->next;
		else{
			pom=*first;
			while(pom->next && pom->next!=novi)
				pom=pom->next;
			pom->next=novi->next;
		}
		ubaci(&firstnovi,novi);	
	}

	return firstnovi;
}

//za tesitranje nam treba ispis
void ispis(tvrtka* first)
{
	while(first){
		printf("%s %g\n", first->naziv, first->vrijednost);
		first=first->next;
	}
	printf("\n");
}

int main(void)
{
	FILE *in;
	tvrtka *first=NULL, *novi, *pom;
	char naziv[51];
	double vrijednost;

	if((in=fopen("tvrtka.txt","rt"))==NULL){
		printf("Greska prilikom otvaranja datoteke!");
		exit(1);
	}
	
	while(fscanf(in,"%s %lf", naziv, &vrijednost)>0){
		novi=(tvrtka*)malloc(sizeof(tvrtka));
		strcpy(novi->naziv,naziv);
		novi->vrijednost=vrijednost;
		
		if(!first)
			pom=first=novi;
		else{
			pom->next=novi;
			pom=pom->next;
		}
	}
	pom->next=NULL;
	
	ispis(first);
	
	//first=igra(first,"Ante","Jelena");
	//ispis(first);

	//first=igra(first,"Ante","Emanuel");
	//ispis(first);

	novi=predstecaj(&first);
	ispis(first);
	ispis(novi);

	for(pom=first; pom; pom=first){
		pom=first;
		first=first->next;
		free(pom);
	}

	return 0;
}
