#include <stdio.h>
#include <string.h>

typedef struct
{
    char sifra[11];
    char naziv[101];
    int ocjena;
} anketa;

typedef struct
{
    int broj;
    int uk_ocjena;
    char naziv[101];
} proizvod;

int indexProizvoda(const char *naziv, proizvod *niz, int *n)
{
    int i;
    for (i = 0; i < *n; ++i)
        if (!strcmp(naziv, niz[i].naziv))
            return i;
    strcpy(niz[i].naziv, naziv);
    niz[i].broj = 0;
    niz[i].uk_ocjena = 0;
    *n = i+1;
    return i;
}

int main()
{
    FILE *in = fopen("ankete.dat", "rb");
    FILE *out = fopen("proizvodi.txt", "wt");
    proizvod niz[300];
    anketa A;
    int i, j, n = 0;

    while (fread(&A, 1, sizeof(anketa), in))
    {
        i = indexProizvoda(A.naziv, niz, &n);
        niz[i].broj++;
        niz[i].uk_ocjena += A.ocjena;
    }

    for (i = 0; i < n; ++i)
        for (j = i+1; j < n; ++j)
            if ( niz[i].uk_ocjena*niz[j].broj <
                 niz[j].uk_ocjena*niz[i].broj )
            {
                proizvod tmp;
                tmp = niz[i]; niz[i] = niz[j]; niz[j] = tmp;
            }

    for (i = 0; i < n; ++i)
        fprintf(out, "%s: %.3lf\n", niz[i].naziv,
                (double)niz[i].uk_ocjena/niz[i].broj);

    fclose(in);
    fclose(out);
    return 0;
}
